--- old/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_api.c	Mon Aug  5 17:28:23 2019
+++ new/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_api.c	Mon Aug  5 17:28:23 2019
@@ -1230,40 +1414,26 @@
 		}
 		progress |= QL_HBA_BUFFER_SETUP;
 
-		/* Setup buffer pointers. */
-		ha->request_dvma = ha->hba_buf.cookie.dmac_laddress +
-		    REQUEST_Q_BUFFER_OFFSET;
-		ha->request_ring_bp = (struct cmd_entry *)
-		    ((caddr_t)ha->hba_buf.bp + REQUEST_Q_BUFFER_OFFSET);
-
-		ha->response_dvma = ha->hba_buf.cookie.dmac_laddress +
-		    RESPONSE_Q_BUFFER_OFFSET;
-		ha->response_ring_bp = (struct sts_entry *)
-		    ((caddr_t)ha->hba_buf.bp + RESPONSE_Q_BUFFER_OFFSET);
-
-		ha->rcvbuf_dvma = ha->hba_buf.cookie.dmac_laddress +
-		    RCVBUF_Q_BUFFER_OFFSET;
-		ha->rcvbuf_ring_bp = (struct rcvbuf *)
-		    ((caddr_t)ha->hba_buf.bp + RCVBUF_Q_BUFFER_OFFSET);
-
 		/* Allocate resource for QLogic IOCTL */
 		(void) ql_alloc_xioctl_resource(ha);
 
-		/* Setup interrupts */
-		if ((rval = ql_setup_interrupts(ha)) != DDI_SUCCESS) {
-			cmn_err(CE_WARN, "%s(%d): Failed to add interrupt, "
-			    "rval=%xh", QL_NAME, instance, rval);
+
+		if (ql_nvram_cache_desc_ctor(ha) != DDI_SUCCESS) {
+			cmn_err(CE_WARN, "%s(%d): can't setup nvram cache",
+			    QL_NAME, instance);
 			goto attach_failed;
 		}
 
-		progress |= (QL_INTR_ADDED | QL_MUTEX_CV_INITED);
+		progress |= QL_NVRAM_CACHE_CREATED;
 
-		if (ql_nvram_cache_desc_ctor(ha) != DDI_SUCCESS) {
-			cmn_err(CE_WARN, "%s(%d): can't setup nvram cache",
+		if (ql_plogi_params_desc_ctor(ha) != DDI_SUCCESS) {
+			cmn_err(CE_WARN, "%s(%d): can't setup plogi params",
 			    QL_NAME, instance);
 			goto attach_failed;
 		}
 
+		progress |= QL_PLOGI_PARAMS_CREATED;
+
 		/*
 		 * Allocate an N Port information structure
 		 * for use when in P2P topology.
@@ -1354,15 +1524,15 @@
 			cmn_err(CE_NOTE, "!%s(%d): Firmware not loaded",
 			    QL_NAME, ha->instance);
 		} else {
-			int	rval;
+			int	rval, rval1;
 			char	ver_fmt[256];
 
-			rval = (int)snprintf(ver_fmt, (size_t)sizeof (ver_fmt),
+			rval1 = (int)snprintf(ver_fmt, (size_t)sizeof (ver_fmt),
 			    "Firmware version %d.%d.%d", ha->fw_major_version,
 			    ha->fw_minor_version, ha->fw_subminor_version);
 
 			if (CFG_IST(ha, CFG_CTRL_81XX)) {
-				rval = (int)snprintf(ver_fmt + rval,
+				rval = (int)snprintf(ver_fmt + rval1,
 				    (size_t)sizeof (ver_fmt),
 				    ", MPI fw version %d.%d.%d",
 				    ha->mpi_fw_major_version,
@@ -1371,7 +1541,7 @@
 
 				if (ha->subsys_id == 0x17B ||
 				    ha->subsys_id == 0x17D) {
-					(void) snprintf(ver_fmt + rval,
+					(void) snprintf(ver_fmt + rval1 + rval,
 					    (size_t)sizeof (ver_fmt),
 					    ", PHY fw version %d.%d.%d",
 					    ha->phy_fw_major_version,
@@ -1422,43 +1592,70 @@
 		/* fill in the structure */
 		tran->fca_numports = 1;
 		tran->fca_version = FCTL_FCA_MODREV_5;
-		if (CFG_IST(ha, CFG_CTRL_2422)) {
-			tran->fca_num_npivports = MAX_24_VIRTUAL_PORTS;
-		} else if (CFG_IST(ha, CFG_CTRL_2581)) {
-			tran->fca_num_npivports = MAX_25_VIRTUAL_PORTS;
-		}
+		tran->fca_num_npivports = ha->max_vports ?
+		    ha->max_vports - 1 : 0;
 		bcopy(ha->loginparams.node_ww_name.raw_wwn,
 		    tran->fca_perm_pwwn.raw_wwn, 8);
 
-		EL(ha, "FCA version %d\n", tran->fca_version);
+		if (CFG_IST(ha, CFG_ENABLE_64BIT_ADDRESSING)) {
+			ha->io_dma_attr = ha->bit64_io_dma_attr;
+			ha->fcsm_cmd_dma_attr = ha->bit64_io_dma_attr;
+			ha->fcsm_rsp_dma_attr = ha->bit64_io_dma_attr;
+			ha->fcip_cmd_dma_attr = ha->bit64_io_dma_attr;
+			ha->fcip_rsp_dma_attr = ha->bit64_io_dma_attr;
+			ha->fcp_cmd_dma_attr = ha->bit64_io_dma_attr;
+			ha->fcp_rsp_dma_attr = ha->bit64_io_dma_attr;
+			ha->fcp_data_dma_attr = ha->bit64_io_dma_attr;
+		} else {
+			ha->io_dma_attr = ha->bit32_io_dma_attr;
+			ha->fcsm_cmd_dma_attr = ha->bit32_io_dma_attr;
+			ha->fcsm_rsp_dma_attr = ha->bit32_io_dma_attr;
+			ha->fcip_cmd_dma_attr = ha->bit32_io_dma_attr;
+			ha->fcip_rsp_dma_attr = ha->bit32_io_dma_attr;
+			ha->fcp_cmd_dma_attr = ha->bit32_io_dma_attr;
+			ha->fcp_rsp_dma_attr = ha->bit32_io_dma_attr;
+			ha->fcp_data_dma_attr = ha->bit32_io_dma_attr;
+		}
+		ha->fcsm_cmd_dma_attr.dma_attr_sgllen = QL_FCSM_CMD_SGLLEN;
+		ha->fcsm_rsp_dma_attr.dma_attr_sgllen = QL_FCSM_RSP_SGLLEN;
+		ha->fcip_cmd_dma_attr.dma_attr_sgllen = QL_FCIP_CMD_SGLLEN;
+		ha->fcip_rsp_dma_attr.dma_attr_sgllen = QL_FCIP_RSP_SGLLEN;
+		ha->fcp_cmd_dma_attr.dma_attr_sgllen = QL_FCP_CMD_SGLLEN;
+		ha->fcp_rsp_dma_attr.dma_attr_sgllen = QL_FCP_RSP_SGLLEN;
+		if (CFG_IST(ha, CFG_CTRL_82XX)) {
+			ha->io_dma_attr.dma_attr_flags |=
+			    DDI_DMA_RELAXED_ORDERING;
+			ha->fcsm_cmd_dma_attr.dma_attr_flags |=
+			    DDI_DMA_RELAXED_ORDERING;
+			ha->fcsm_rsp_dma_attr.dma_attr_flags |=
+			    DDI_DMA_RELAXED_ORDERING;
+			ha->fcip_cmd_dma_attr.dma_attr_flags |=
+			    DDI_DMA_RELAXED_ORDERING;
+			ha->fcip_rsp_dma_attr.dma_attr_flags |=
+			    DDI_DMA_RELAXED_ORDERING;
+			ha->fcp_cmd_dma_attr.dma_attr_flags |=
+			    DDI_DMA_RELAXED_ORDERING;
+			ha->fcp_rsp_dma_attr.dma_attr_flags |=
+			    DDI_DMA_RELAXED_ORDERING;
+			ha->fcp_data_dma_attr.dma_attr_flags |=
+			    DDI_DMA_RELAXED_ORDERING;
+		}
 
 		/* Specify the amount of space needed in each packet */
 		tran->fca_pkt_size = sizeof (ql_srb_t);
 
 		/* command limits are usually dictated by hardware */
-		tran->fca_cmd_max = MAX_OUTSTANDING_COMMANDS;
+		tran->fca_cmd_max = ha->osc_max_cnt;
 
 		/* dmaattr are static, set elsewhere. */
-		if (CFG_IST(ha, CFG_ENABLE_64BIT_ADDRESSING)) {
-			tran->fca_dma_attr = &ql_64bit_io_dma_attr;
-			tran->fca_dma_fcp_cmd_attr = &ql_64fcp_cmd_dma_attr;
-			tran->fca_dma_fcp_rsp_attr = &ql_64fcp_rsp_dma_attr;
-			tran->fca_dma_fcp_data_attr = &ql_64fcp_data_dma_attr;
-			tran->fca_dma_fcsm_cmd_attr = &ql_64fcsm_cmd_dma_attr;
-			tran->fca_dma_fcsm_rsp_attr = &ql_64fcsm_rsp_dma_attr;
-			tran->fca_dma_fcip_cmd_attr = &ql_64fcip_cmd_dma_attr;
-			tran->fca_dma_fcip_rsp_attr = &ql_64fcip_rsp_dma_attr;
-		} else {
-			tran->fca_dma_attr = &ql_32bit_io_dma_attr;
-			tran->fca_dma_fcp_cmd_attr = &ql_32fcp_cmd_dma_attr;
-			tran->fca_dma_fcp_rsp_attr = &ql_32fcp_rsp_dma_attr;
-			tran->fca_dma_fcp_data_attr = &ql_32fcp_data_dma_attr;
-			tran->fca_dma_fcsm_cmd_attr = &ql_32fcsm_cmd_dma_attr;
-			tran->fca_dma_fcsm_rsp_attr = &ql_32fcsm_rsp_dma_attr;
-			tran->fca_dma_fcip_cmd_attr = &ql_32fcip_cmd_dma_attr;
-			tran->fca_dma_fcip_rsp_attr = &ql_32fcip_rsp_dma_attr;
-		}
-
+		tran->fca_dma_attr = &ha->io_dma_attr;
+		tran->fca_dma_fcp_cmd_attr = &ha->fcp_cmd_dma_attr;
+		tran->fca_dma_fcp_rsp_attr = &ha->fcp_rsp_dma_attr;
+		tran->fca_dma_fcp_data_attr = &ha->fcp_data_dma_attr;
+		tran->fca_dma_fcsm_cmd_attr = &ha->fcsm_cmd_dma_attr;
+		tran->fca_dma_fcsm_rsp_attr = &ha->fcsm_rsp_dma_attr;
+		tran->fca_dma_fcip_cmd_attr = &ha->fcip_cmd_dma_attr;
+		tran->fca_dma_fcip_rsp_attr = &ha->fcip_rsp_dma_attr;
 		tran->fca_acc_attr = &ql_dev_acc_attr;
 		tran->fca_iblock = &(ha->iblock_cookie);
 
@@ -1480,6 +1677,9 @@
 		tran->fca_port_manage = ql_port_manage;
 		tran->fca_get_device = ql_get_device;
 
+		EL(ha, "Transport interface setup. FCA version %d\n",
+		    tran->fca_version);
+
 		/* give it to the FC transport */
 		if (fc_fca_attach(dip, tran) != DDI_SUCCESS) {
 			cmn_err(CE_WARN, "%s(%d): FCA attach failed", QL_NAME,
@@ -1497,23 +1697,39 @@
 		/* Add adapter structure to link list. */
 		ql_add_link_b(&ql_hba, &ha->hba);
 
+		/* Determine and populate HBA fru info */
+		ql_setup_fruinfo(ha);
+
+		/* Release global state lock. */
+		GLOBAL_STATE_UNLOCK();
+
 		/* Start one second driver timer. */
+		GLOBAL_TIMER_LOCK();
 		if (ql_timer_timeout_id == NULL) {
 			ql_timer_ticks = drv_usectohz(1000000);
 			ql_timer_timeout_id = timeout(ql_timer, (void *)0,
 			    ql_timer_ticks);
 		}
+		GLOBAL_TIMER_UNLOCK();
 
-		/* Release global state lock. */
-		GLOBAL_STATE_UNLOCK();
-
-		/* Determine and populate HBA fru info */
-		ql_setup_fruinfo(ha);
-
 		/* Setup task_daemon thread. */
-		(void) thread_create(NULL, 0, (void (*)())ql_task_daemon, ha,
-		    0, &p0, TS_RUN, minclsyspri);
+		(void) snprintf(taskq_name, sizeof (taskq_name),
+		    "qlc_%d_driver_thread", instance);
+		ha->driver_thread_taskq = ddi_taskq_create(NULL, taskq_name, 1,
+		    TASKQ_DEFAULTPRI, 0);
+		(void) ddi_taskq_dispatch(ha->driver_thread_taskq,
+		    ql_task_daemon, ha, DDI_SLEEP);
+		ha->task_daemon_flags |= TASK_DAEMON_ALIVE_FLG;
 
+		(void) snprintf(taskq_name, sizeof (taskq_name),
+		    "qlc_%d_comp_thd", instance);
+		ha->completion_taskq = ddi_taskq_create(0, taskq_name,
+		    ha->completion_thds, maxclsyspri, 0);
+		for (size = 0; size < ha->completion_thds; size++) {
+			(void) ddi_taskq_dispatch(ha->completion_taskq,
+			    ql_completion_thread, ha, DDI_SLEEP);
+		}
+
 		progress |= QL_TASK_DAEMON_STARTED;
 
 		ddi_report_dev(dip);
@@ -1525,6 +1741,11 @@
 		break;
 
 attach_failed:
+		if (progress & QL_FCA_INIT_FM) {
+			qlc_fm_fini(ha);
+			progress &= ~QL_FCA_INIT_FM;
+		}
+
 		if (progress & QL_FCA_ATTACH_DONE) {
 			(void) fc_fca_detach(dip);
 			progress &= ~QL_FCA_ATTACH_DONE;
@@ -1550,19 +1771,44 @@
 			progress &= ~QL_N_PORT_INFO_CREATED;
 		}
 
-		if (progress & QL_TASK_DAEMON_STARTED) {
-			TASK_DAEMON_LOCK(ha);
+		if (progress & QL_PLOGI_PARAMS_CREATED) {
+			(void) ql_plogi_params_desc_dtor(ha);
+			progress &= ~QL_PLOGI_PARAMS_CREATED;
+		}
 
-			ha->task_daemon_flags |= TASK_DAEMON_STOP_FLG;
+		if (progress & QL_NVRAM_CACHE_CREATED) {
+			(void) ql_nvram_cache_desc_dtor(ha);
+			progress &= ~QL_NVRAM_CACHE_CREATED;
+		}
 
-			cv_signal(&ha->cv_task_daemon);
+		if (progress & QL_TASK_DAEMON_STARTED) {
+			if (ha->driver_thread_taskq) {
+				while (ha->task_daemon_flags &
+				    TASK_DAEMON_ALIVE_FLG) {
+					/* Delay for 1 tick (10 ms). */
+					ql_awaken_task_daemon(ha, NULL,
+					    TASK_DAEMON_STOP_FLG, 0);
+					delay(1);
+				}
+				ha->task_daemon_flags &= ~TASK_DAEMON_STOP_FLG;
 
-			/* Release task daemon lock. */
-			TASK_DAEMON_UNLOCK(ha);
+				ddi_taskq_destroy(ha->driver_thread_taskq);
+				ha->driver_thread_taskq = NULL;
+			}
+			if (ha->completion_taskq) {
+				ADAPTER_STATE_LOCK(ha);
+				ha->flags |= COMP_THD_TERMINATE;
+				ADAPTER_STATE_UNLOCK(ha);
 
-			/* Wait for for task daemon to stop running. */
-			while (ha->task_daemon_flags & TASK_DAEMON_STOP_FLG) {
-				ql_delay(ha, 10000);
+				do {
+					COMP_Q_LOCK(ha);
+					cv_broadcast(&ha->cv_comp_thread);
+					COMP_Q_UNLOCK(ha);
+					ql_delay(ha, 10000);
+				} while (ha->comp_thds_active != 0);
+
+				ddi_taskq_destroy(ha->completion_taskq);
+				ha->completion_taskq = NULL;
 			}
 			progress &= ~QL_TASK_DAEMON_STARTED;
 		}
@@ -1576,6 +1822,12 @@
 			ddi_regs_map_free(&ha->iomap_dev_handle);
 			progress &= ~QL_IOMAP_IOBASE_MAPPED;
 		}
+		if (progress & QL_REGS_MAPPED) {
+			if (ha->mbar_dev_handle) {
+				ddi_regs_map_free(&ha->mbar_dev_handle);
+				ha->mbar_dev_handle = 0;
+			}
+		}
 
 		if (progress & QL_CONFIG_SPACE_SETUP) {
 			if (CFG_IST(ha, CFG_SBUS_CARD)) {
@@ -1598,7 +1850,7 @@
 		}
 
 		if (progress & QL_HBA_BUFFER_SETUP) {
-			ql_free_phys(ha, &ha->hba_buf);
+			ql_delete_queues(ha);
 			progress &= ~QL_HBA_BUFFER_SETUP;
 		}
 
@@ -1620,9 +1872,11 @@
 			kmem_free(ha->ub_array, sizeof (*ha->ub_array) *
 			    QL_UB_LIMIT);
 
-			kmem_free(ha->outstanding_cmds,
-			    sizeof (*ha->outstanding_cmds) *
-			    MAX_OUTSTANDING_COMMANDS);
+			if (ha->outstanding_cmds != NULL) {
+				kmem_free(ha->outstanding_cmds,
+				    sizeof (*ha->outstanding_cmds) *
+				    ha->osc_max_cnt);
+			}
 
 			if (ha->devpath != NULL) {
 				kmem_free(ha->devpath,
@@ -1639,8 +1893,7 @@
 			if (ha->fw_module != NULL) {
 				(void) ddi_modclose(ha->fw_module);
 			}
-			(void) ql_el_trace_desc_dtor(ha);
-			(void) ql_nvram_cache_desc_dtor(ha);
+			(void) ql_el_trace_dealloc(ha);
 
 			ddi_soft_state_free(ql_state, instance);
 			progress &= ~QL_SOFT_STATE_ALLOCED;
@@ -1689,30 +1942,19 @@
 			    0);
 		}
 
-		/* Acquire global state lock. */
-		GLOBAL_STATE_LOCK();
-
 		/* Restart driver timer. */
+		GLOBAL_TIMER_LOCK();
 		if (ql_timer_timeout_id == NULL) {
 			ql_timer_timeout_id = timeout(ql_timer, (void *)0,
 			    ql_timer_ticks);
 		}
+		GLOBAL_TIMER_LOCK();
 
-		/* Release global state lock. */
-		GLOBAL_STATE_UNLOCK();
-
 		/* Wake up command start routine. */
 		ADAPTER_STATE_LOCK(ha);
 		ha->flags &= ~ADAPTER_SUSPENDED;
 		ADAPTER_STATE_UNLOCK(ha);
 
-		/*
-		 * Transport doesn't make FC discovery in polled
-		 * mode; So we need the daemon thread's services
-		 * right here.
-		 */
-		(void) callb_generic_cpr(&ha->cprinfo, CB_CODE_CPR_RESUME);
-
 		rval = DDI_SUCCESS;
 
 		/* Restart IP if it was running. */
@@ -1733,11 +1975,11 @@
 
 	if (rval != DDI_SUCCESS) {
 		/*EMPTY*/
-		QL_PRINT_2(CE_CONT, "(%d): failed, rval = %xh\n",
+		QL_PRINT_2(ha, "failed instance=%d, rval = %xh\n",
 		    ddi_get_instance(dip), rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ddi_get_instance(dip));
+		QL_PRINT_3(ha, "done\n");
 	}
 
 	return (rval);
@@ -1764,7 +2006,6 @@
 {
 	ql_adapter_state_t	*ha, *vha;
 	ql_tgt_t		*tq;
-	int			delay_cnt;
 	uint16_t		index;
 	ql_link_t		*link;
 	char			*buf;
@@ -1773,12 +2014,12 @@
 
 	ha = ddi_get_soft_state(ql_state, ddi_get_instance(dip));
 	if (ha == NULL) {
-		QL_PRINT_2(CE_CONT, "(%d): no adapter\n",
+		QL_PRINT_2(NULL, "no adapter, instance=%d\n",
 		    ddi_get_instance(dip));
 		return (DDI_FAILURE);
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): started, cmd=%xh\n", ha->instance, cmd);
+	QL_PRINT_3(ha, "started, cmd=%xh\n", cmd);
 
 	buf = (char *)(kmem_zalloc(MAXPATHLEN, KM_SLEEP));
 
@@ -1788,40 +2029,60 @@
 		ha->flags |= (ADAPTER_SUSPENDED | ABORT_CMDS_LOOP_DOWN_TMO);
 		ADAPTER_STATE_UNLOCK(ha);
 
-		TASK_DAEMON_LOCK(ha);
+		/* Wait for task thread to see suspend flag. */
+		while (!(ha->task_daemon_flags & TASK_DAEMON_STALLED_FLG) &&
+		    ha->task_daemon_flags & TASK_DAEMON_ALIVE_FLG) {
+			ql_awaken_task_daemon(ha, NULL, 0, 0);
+			/* Delay for 1 tick (10 milliseconds). */
+			delay(1);
+		}
 
-		if (ha->task_daemon_flags & TASK_DAEMON_ALIVE_FLG) {
-			ha->task_daemon_flags |= TASK_DAEMON_STOP_FLG;
-			cv_signal(&ha->cv_task_daemon);
+		if (ha->driver_thread_taskq) {
+			while (ha->task_daemon_flags & TASK_DAEMON_ALIVE_FLG) {
+				/* Delay for 1 tick (10 milliseconds). */
+				ql_awaken_task_daemon(ha, NULL,
+				    TASK_DAEMON_STOP_FLG, 0);
+				delay(1);
+			}
+			ha->task_daemon_flags &= ~TASK_DAEMON_STOP_FLG;
 
-			TASK_DAEMON_UNLOCK(ha);
+			ddi_taskq_destroy(ha->driver_thread_taskq);
+			ha->driver_thread_taskq = NULL;
+		}
 
-			(void) ql_wait_for_td_stop(ha);
+		if (ha->completion_taskq) {
+			ADAPTER_STATE_LOCK(ha);
+			ha->flags |= COMP_THD_TERMINATE;
+			ADAPTER_STATE_UNLOCK(ha);
 
-			TASK_DAEMON_LOCK(ha);
-			if (ha->task_daemon_flags & TASK_DAEMON_STOP_FLG) {
-				ha->task_daemon_flags &= ~TASK_DAEMON_STOP_FLG;
-				EL(ha, "failed, could not stop task daemon\n");
-			}
+			do {
+				COMP_Q_LOCK(ha);
+				cv_broadcast(&ha->cv_comp_thread);
+				COMP_Q_UNLOCK(ha);
+				ql_delay(ha, 10000);
+			} while (ha->comp_thds_active != 0);
+
+			ddi_taskq_destroy(ha->completion_taskq);
+			ha->completion_taskq = NULL;
 		}
-		TASK_DAEMON_UNLOCK(ha);
 
-		GLOBAL_STATE_LOCK();
-
 		/* Disable driver timer if no adapters. */
+		GLOBAL_TIMER_LOCK();
 		if (ql_timer_timeout_id && ql_hba.first == &ha->hba &&
 		    ql_hba.last == &ha->hba) {
 			timer_id = ql_timer_timeout_id;
 			ql_timer_timeout_id = NULL;
 		}
-		ql_remove_link(&ql_hba, &ha->hba);
+		GLOBAL_TIMER_UNLOCK();
 
-		GLOBAL_STATE_UNLOCK();
-
 		if (timer_id) {
 			(void) untimeout(timer_id);
 		}
 
+		GLOBAL_STATE_LOCK();
+		ql_remove_link(&ql_hba, &ha->hba);
+		GLOBAL_STATE_UNLOCK();
+
 		if (ha->pm_capable) {
 			if (pm_lower_power(dip, QL_POWER_COMPONENT,
 			    PM_LEVEL_D3) != DDI_SUCCESS) {
@@ -1909,7 +2170,7 @@
 		if (CFG_IST(ha, CFG_SBUS_CARD)) {
 			ddi_regs_map_free(&ha->sbus_config_handle);
 		} else {
-			if (CFG_IST(ha, CFG_CTRL_8021)) {
+			if (CFG_IST(ha, CFG_CTRL_82XX)) {
 				ql_8021_clr_drv_active(ha);
 				ddi_regs_map_free(&ha->db_dev_handle);
 			}
@@ -1926,7 +2187,7 @@
 
 		ql_destroy_mutex(ha);
 
-		ql_free_phys(ha, &ha->hba_buf);
+		ql_delete_queues(ha);
 		ql_free_phys(ha, &ha->fwexttracebuf);
 		ql_free_phys(ha, &ha->fwfcetracebuf);
 
@@ -1934,6 +2195,9 @@
 		if (ha->sbus_fpga_iobase != NULL) {
 			ddi_regs_map_free(&ha->sbus_fpga_dev_handle);
 		}
+		if (ha->mbar_dev_handle != NULL) {
+			ddi_regs_map_free(&ha->mbar_dev_handle);
+		}
 
 		ql_fcache_rel(ha->fcache);
 		if (ha->vcache != NULL) {
@@ -1949,7 +2213,7 @@
 		kmem_free(ha->ub_array, sizeof (*ha->ub_array) * QL_UB_LIMIT);
 
 		kmem_free(ha->outstanding_cmds,
-		    sizeof (*ha->outstanding_cmds) * MAX_OUTSTANDING_COMMANDS);
+		    sizeof (*ha->outstanding_cmds) * ha->osc_max_cnt);
 
 		if (ha->n_port != NULL) {
 			kmem_free(ha->n_port, sizeof (ql_n_port_info_t));
@@ -1961,34 +2225,40 @@
 
 		kmem_free(ha->dev, sizeof (*ha->dev) * DEVICE_HEAD_LIST_SIZE);
 
+		(void) ql_plogi_params_desc_dtor(ha);
+
+		(void) ql_nvram_cache_desc_dtor(ha);
+
+		(void) qlc_fm_fini(ha);
+
 		EL(ha, "detached\n");
 
+		(void) ql_el_trace_dealloc(ha);
+
 		ddi_soft_state_free(ql_state, (int)ha->instance);
 
+		rval = DDI_SUCCESS;
+
 		break;
 
 	case DDI_SUSPEND:
 		ADAPTER_STATE_LOCK(ha);
-
-		delay_cnt = 0;
 		ha->flags |= ADAPTER_SUSPENDED;
-		while (ha->flags & ADAPTER_TIMER_BUSY && delay_cnt++ < 10) {
-			ADAPTER_STATE_UNLOCK(ha);
-			delay(drv_usectohz(1000000));
-			ADAPTER_STATE_LOCK(ha);
+		ADAPTER_STATE_UNLOCK(ha);
+
+		/* Disable driver timer if last adapter. */
+		GLOBAL_TIMER_LOCK();
+		if (ql_timer_timeout_id && ql_hba.first == &ha->hba &&
+		    ql_hba.last == &ha->hba) {
+			timer_id = ql_timer_timeout_id;
+			ql_timer_timeout_id = NULL;
 		}
-		if (ha->busy || ha->flags & ADAPTER_TIMER_BUSY) {
-			ha->flags &= ~ADAPTER_SUSPENDED;
-			ADAPTER_STATE_UNLOCK(ha);
-			rval = DDI_FAILURE;
-			cmn_err(CE_WARN, "!%s(%d): Fail suspend"
-			    " busy %xh flags %xh", QL_NAME, ha->instance,
-			    ha->busy, ha->flags);
-			break;
+		GLOBAL_TIMER_UNLOCK();
+
+		if (timer_id) {
+			(void) untimeout(timer_id);
 		}
 
-		ADAPTER_STATE_UNLOCK(ha);
-
 		if (ha->flags & IP_INITIALIZED) {
 			(void) ql_shutdown_ip(ha);
 		}
@@ -2010,21 +2280,6 @@
 			break;
 		}
 
-		/* Acquire global state lock. */
-		GLOBAL_STATE_LOCK();
-
-		/* Disable driver timer if last adapter. */
-		if (ql_timer_timeout_id && ql_hba.first == &ha->hba &&
-		    ql_hba.last == &ha->hba) {
-			timer_id = ql_timer_timeout_id;
-			ql_timer_timeout_id = NULL;
-		}
-		GLOBAL_STATE_UNLOCK();
-
-		if (timer_id) {
-			(void) untimeout(timer_id);
-		}
-
 		EL(ha, "suspended\n");
 
 		break;
@@ -2037,22 +2292,15 @@
 	kmem_free(buf, MAXPATHLEN);
 
 	if (rval != DDI_SUCCESS) {
-		if (ha != NULL) {
-			EL(ha, "failed, rval = %xh\n", rval);
-		} else {
-			/*EMPTY*/
-			QL_PRINT_2(CE_CONT, "(%d): failed, rval = %xh\n",
-			    ddi_get_instance(dip), rval);
-		}
+		EL(ha, "failed, rval = %xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ddi_get_instance(dip));
+		QL_PRINT_3(ha, "done\n");
 	}
 
 	return (rval);
 }
 
-
 /*
  * ql_power
  *	Power a device attached to the system.
@@ -2081,12 +2329,11 @@
 
 	ha = ddi_get_soft_state(ql_state, ddi_get_instance(dip));
 	if (ha == NULL || ha->pm_capable == 0) {
-		QL_PRINT_2(CE_CONT, "(%d): no hba or PM not supported\n",
-		    ddi_get_instance(dip));
+		QL_PRINT_2(ha, "no hba or PM not supported\n");
 		return (rval);
 	}
 
-	QL_PRINT_10(CE_CONT, "(%d,%d): started\n", ha->instance, ha->vp_index);
+	QL_PRINT_10(ha, "started\n");
 
 	buf = (char *)(kmem_zalloc(MAXPATHLEN, KM_SLEEP));
 	path = (char *)(kmem_zalloc(MAXPATHLEN, KM_SLEEP));
@@ -2102,7 +2349,7 @@
 	csr = (uint8_t)ql_pci_config_get8(ha, PCI_CONF_CAP_PTR) + PCI_PMCSR;
 	GLOBAL_HW_UNLOCK();
 
-	(void) snprintf(buf, sizeof (buf),
+	(void) snprintf(buf, MAXPATHLEN,
 	    "Qlogic %s(%d): %s\n\t", QL_NAME, ddi_get_instance(dip),
 	    ddi_pathname(dip, path));
 
@@ -2172,7 +2419,7 @@
 
 		QL_PM_LOCK(ha);
 
-		if (ha->busy || ((ha->task_daemon_flags &
+		if (ha->pm_busy || ((ha->task_daemon_flags &
 		    TASK_DAEMON_SLEEPING_FLG) == 0)) {
 			QL_PM_UNLOCK(ha);
 			break;
@@ -2229,7 +2476,7 @@
 	kmem_free(buf, MAXPATHLEN);
 	kmem_free(path, MAXPATHLEN);
 
-	QL_PRINT_10(CE_CONT, "(%d,%d): done\n", ha->instance, ha->vp_index);
+	QL_PRINT_10(ha, "done\n");
 
 	return (rval);
 }
@@ -2257,18 +2504,58 @@
 	ha = ddi_get_soft_state(ql_state, ddi_get_instance(dip));
 	if (ha == NULL) {
 		/* Oh well.... */
-		QL_PRINT_2(CE_CONT, "(%d): no adapter\n",
+		QL_PRINT_2(NULL, "no adapter, instance=%d\n",
 		    ddi_get_instance(dip));
 		return (DDI_SUCCESS);
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
-	if (CFG_IST(ha, CFG_CTRL_8021)) {
-		(void) ql_stop_firmware(ha);
-	} else if (CFG_IST(ha, CFG_CTRL_242581)) {
+	if (CFG_IST(ha, CFG_CTRL_82XX)) {
+		ql_8021_clr_hw_intr(ha);
+		ql_8021_clr_fw_intr(ha);
+		WRT16_IO_REG(ha, mailbox_in[0], MBC_TOGGLE_INTERRUPT);
+		WRT16_IO_REG(ha, mailbox_in[1], 0);
+		WRT32_IO_REG(ha, nx_host_int, NX_MBX_CMD);
+		for (timer = 0; timer < 20000; timer++) {
+			stat = RD32_IO_REG(ha, risc2host);
+			if (stat & BIT_15) {
+				ql_8021_clr_hw_intr(ha);
+				if ((stat & 0xff) < 0x12) {
+					ql_8021_clr_fw_intr(ha);
+					break;
+				}
+				ql_8021_clr_fw_intr(ha);
+			}
+			drv_usecwait(100);
+		}
+		ql_8021_wr_32(ha, ha->nx_legacy_intr.tgt_mask_reg, 0x0400);
+		WRT16_IO_REG(ha, mailbox_in[0], MBC_STOP_FIRMWARE);
+		WRT16_IO_REG(ha, mailbox_in[1], 0);
+		WRT32_IO_REG(ha, nx_host_int, NX_MBX_CMD);
+		for (timer = 0; timer < 20000; timer++) {
+			stat = RD32_IO_REG(ha, risc2host);
+			if (stat & BIT_15) {
+				ql_8021_clr_hw_intr(ha);
+				if ((stat & 0xff) < 0x12) {
+					ql_8021_clr_fw_intr(ha);
+					break;
+				}
+				ql_8021_clr_fw_intr(ha);
+			}
+			drv_usecwait(100);
+		}
+	} else if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 		WRT32_IO_REG(ha, hccr, HC24_CLR_RISC_INT);
 		WRT16_IO_REG(ha, mailbox_in[0], MBC_STOP_FIRMWARE);
+		WRT16_IO_REG(ha, mailbox_in[1], 0);
+		WRT16_IO_REG(ha, mailbox_in[2], 0);
+		WRT16_IO_REG(ha, mailbox_in[3], 0);
+		WRT16_IO_REG(ha, mailbox_in[4], 0);
+		WRT16_IO_REG(ha, mailbox_in[5], 0);
+		WRT16_IO_REG(ha, mailbox_in[6], 0);
+		WRT16_IO_REG(ha, mailbox_in[7], 0);
+		WRT16_IO_REG(ha, mailbox_in[8], 0);
 		WRT32_IO_REG(ha, hccr, HC24_SET_HOST_INT);
 		for (timer = 0; timer < 30000; timer++) {
 			stat = RD32_IO_REG(ha, risc2host);
@@ -2283,8 +2570,12 @@
 			drv_usecwait(100);
 		}
 		/* Reset the chip. */
-		WRT32_IO_REG(ha, ctrl_status, ISP_RESET | DMA_SHUTDOWN |
-		    MWB_4096_BYTES);
+		if (CFG_IST(ha, CFG_MWB_4096_SUPPORT)) {
+			WRT32_IO_REG(ha, ctrl_status, ISP_RESET | DMA_SHUTDOWN |
+			    MWB_4096_BYTES);
+		} else {
+			WRT32_IO_REG(ha, ctrl_status, ISP_RESET | DMA_SHUTDOWN);
+		}
 		drv_usecwait(100);
 
 	} else {
@@ -2300,10 +2591,8 @@
 		WRT16_IO_REG(ha, hccr, HC_RELEASE_RISC);
 	}
 
-	ql_disable_intr(ha);
+	QL_PRINT_3(ha, "done\n");
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
-
 	return (DDI_SUCCESS);
 }
 
@@ -2344,42 +2633,39 @@
 	/* get state info based on the dip */
 	ha = ddi_get_soft_state(ql_state, ddi_get_instance(dip));
 	if (ha == NULL) {
-		QL_PRINT_2(CE_CONT, "(%d): no adapter\n",
+		QL_PRINT_2(ha, "no adapter, instance=%d\n",
 		    ddi_get_instance(dip));
 		return (NULL);
 	}
-	QL_PRINT_10(CE_CONT, "(%d,%d): started\n", ha->instance, ha->vp_index);
+	QL_PRINT_10(ha, "started\n");
 
 	/* Verify port number is supported. */
 	if (port_npiv != 0) {
 		if (!(ha->flags & VP_ENABLED)) {
-			QL_PRINT_2(CE_CONT, "(%d): FC_NPIV_NOT_SUPPORTED\n",
-			    ha->instance);
+			QL_PRINT_2(ha, "FC_NPIV_NOT_SUPPORTED\n");
 			port_info->pi_error = FC_NPIV_NOT_SUPPORTED;
 			return (NULL);
 		}
 		if (!(ha->flags & POINT_TO_POINT)) {
-			QL_PRINT_2(CE_CONT, "(%d): FC_NPIV_WRONG_TOPOLOGY\n",
-			    ha->instance);
+			QL_PRINT_2(ha, "FC_NPIV_WRONG_TOPOLOGY\n");
 			port_info->pi_error = FC_NPIV_WRONG_TOPOLOGY;
 			return (NULL);
 		}
 		if (!(ha->flags & FDISC_ENABLED)) {
-			QL_PRINT_2(CE_CONT, "(%d): switch does not support "
-			    "FDISC\n", ha->instance);
+			QL_PRINT_2(ha, "switch does not support "
+			    "FDISC\n");
 			port_info->pi_error = FC_NPIV_FDISC_FAILED;
 			return (NULL);
 		}
-		if (bind_info->port_num > (CFG_IST(ha, CFG_CTRL_2422) ?
-		    MAX_24_VIRTUAL_PORTS : MAX_25_VIRTUAL_PORTS)) {
-			QL_PRINT_2(CE_CONT, "(%d): port number=%d "
-			    "FC_OUTOFBOUNDS\n", ha->instance);
+		if (bind_info->port_num >= ha->max_vports) {
+			QL_PRINT_2(ha, "port number=%d "
+			    "FC_OUTOFBOUNDS\n", bind_info->port_num);
 			port_info->pi_error = FC_OUTOFBOUNDS;
 			return (NULL);
 		}
 	} else if (bind_info->port_num != 0) {
-		QL_PRINT_2(CE_CONT, "(%d): failed, port number=%d is not "
-		    "supported\n", ha->instance, bind_info->port_num);
+		QL_PRINT_2(ha, "failed, port number=%d is not "
+		    "supported\n", bind_info->port_num);
 		port_info->pi_error = FC_OUTOFBOUNDS;
 		return (NULL);
 	}
@@ -2408,8 +2694,8 @@
 		}
 		if (vha->vp_index != 0 && !(vha->flags & VP_ENABLED)) {
 			if (ql_vport_enable(vha) != QL_SUCCESS) {
-				QL_PRINT_2(CE_CONT, "(%d): failed to enable "
-				    "virtual port=%d\n", ha->instance,
+				QL_PRINT_2(ha, "failed to enable "
+				    "virtual port=%d\n",
 				    vha->vp_index);
 				port_info->pi_error = FC_NPIV_FDISC_FAILED;
 				return (NULL);
@@ -2428,8 +2714,7 @@
 
 		/* stash the bind_info supplied by the FC Transport */
 		vha->bind_info.port_handle = bind_info->port_handle;
-		vha->bind_info.port_statec_cb =
-		    bind_info->port_statec_cb;
+		vha->bind_info.port_statec_cb = bind_info->port_statec_cb;
 		vha->bind_info.port_unsol_cb = bind_info->port_unsol_cb;
 
 		/* Set port's source ID. */
@@ -2444,7 +2729,7 @@
 		port_info->pi_hard_addr.hard_addr = 0;
 		if (bind_info->port_num == 0) {
 			d_id.b24 = ha->d_id.b24;
-			if (CFG_IST(ha, CFG_CTRL_24258081)) {
+			if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 				if (ha->init_ctrl_blk.cb24.
 				    firmware_options_1[0] & BIT_0) {
 					d_id.b.al_pa = ql_index_to_alpa[ha->
@@ -2496,8 +2781,8 @@
 		port_info->pi_port_state = vha->state;
 	}
 
-	QL_PRINT_10(CE_CONT, "(%d,%d): done, pi_port_state=%xh, "
-	    "pi_s_id.port_id=%xh\n", ha->instance, ha->vp_index,
+	QL_PRINT_10(ha, "done, pi_port_state=%xh, "
+	    "pi_s_id.port_id=%xh\n",
 	    port_info->pi_port_state, port_info->pi_s_id.port_id);
 
 	return (fca_handle);
@@ -2523,25 +2808,23 @@
 	ha = ql_fca_handle_to_state(fca_handle);
 	if (ha == NULL) {
 		/*EMPTY*/
-		QL_PRINT_2(CE_CONT, "failed, no adapter=%ph\n",
+		QL_PRINT_2(NULL, "failed, no adapter=%ph\n",
 		    (void *)fca_handle);
 	} else {
-		QL_PRINT_10(CE_CONT, "(%d,%d): started\n", ha->instance,
-		    ha->vp_index);
+		QL_PRINT_10(ha, "started\n");
 
 		if (!(ha->flags & FCA_BOUND)) {
 			/*EMPTY*/
-			QL_PRINT_2(CE_CONT, "(%d): port=%d already unbound\n",
-			    ha->instance, ha->vp_index);
+			QL_PRINT_2(ha, "port already unbound\n");
 		} else {
 			if (ha->vp_index != 0 && ha->flags & VP_ENABLED) {
+				(void) ql_vport_control(ha, (uint8_t)
+				    (CFG_IST(ha, CFG_FC_TYPE) ?
+				    VPC_DISABLE_INIT : VPC_DISABLE_LOGOUT));
 				if ((tq = ql_loop_id_to_queue(ha,
 				    FL_PORT_24XX_HDL)) != NULL) {
 					(void) ql_logout_fabric_port(ha, tq);
 				}
-				(void) ql_vport_control(ha, (uint8_t)
-				    (CFG_IST(ha, CFG_CTRL_2425) ?
-				    VPC_DISABLE_INIT : VPC_DISABLE_LOGOUT));
 				flgs = FCA_BOUND | VP_ENABLED;
 			} else {
 				flgs = FCA_BOUND;
@@ -2551,8 +2834,7 @@
 			ADAPTER_STATE_UNLOCK(ha);
 		}
 
-		QL_PRINT_10(CE_CONT, "(%d,%d): done\n", ha->instance,
-		    ha->vp_index);
+		QL_PRINT_10(ha, "done\n");
 	}
 }
 
@@ -2583,14 +2865,15 @@
 
 	ha = ql_fca_handle_to_state(fca_handle);
 	if (ha == NULL) {
-		QL_PRINT_2(CE_CONT, "failed, no adapter=%ph\n",
+		QL_PRINT_2(NULL, "failed, no adapter=%ph\n",
 		    (void *)fca_handle);
 		return (FC_UNBOUND);
 	}
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	sp = (ql_srb_t *)pkt->pkt_fca_private;
 	sp->flags = 0;
+	sp->handle = 0;
 
 	/* init cmd links */
 	sp->cmd.base_address = sp;
@@ -2608,11 +2891,11 @@
 	sp->magic_number = QL_FCA_BRAND;
 	sp->sg_dma.dma_handle = NULL;
 #ifndef __sparc
-	if (CFG_IST(ha, CFG_CTRL_8021)) {
+	if (CFG_IST(ha, CFG_CTRL_82XX)) {
 		/* Setup DMA for scatter gather list. */
 		sp->sg_dma.size = sizeof (cmd6_2400_dma_t);
 		sp->sg_dma.type = LITTLE_ENDIAN_DMA;
-		sp->sg_dma.cookie_count = 1;
+		sp->sg_dma.max_cookie_count = 1;
 		sp->sg_dma.alignment = 64;
 		if (ql_alloc_phys(ha, &sp->sg_dma, KM_SLEEP) != QL_SUCCESS) {
 			rval = FC_NOMEM;
@@ -2620,7 +2903,7 @@
 	}
 #endif	/* __sparc */
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (rval);
 }
@@ -2651,11 +2934,11 @@
 
 	ha = ql_fca_handle_to_state(fca_handle);
 	if (ha == NULL) {
-		QL_PRINT_2(CE_CONT, "failed, no adapter=%ph\n",
+		QL_PRINT_2(NULL, "failed, no adapter=%ph\n",
 		    (void *)fca_handle);
 		return (FC_UNBOUND);
 	}
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	sp = (ql_srb_t *)pkt->pkt_fca_private;
 
@@ -2668,7 +2951,7 @@
 		rval = FC_SUCCESS;
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (rval);
 }
@@ -2705,15 +2988,15 @@
 	/* Verify proper command. */
 	ha = ql_cmd_setup(fca_handle, pkt, &rval);
 	if (ha == NULL) {
-		QL_PRINT_2(CE_CONT, "failed, ql_cmd_setup=%xh, fcah=%ph\n",
+		QL_PRINT_2(NULL, "failed, ql_cmd_setup=%xh, fcah=%ph\n",
 		    rval, fca_handle);
 		return (FC_INVALID_REQUEST);
 	}
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	/* Wait for suspension to end. */
 	TASK_DAEMON_LOCK(ha);
-	while (ha->task_daemon_flags & QL_SUSPENDED) {
+	while (DRIVER_SUSPENDED(ha)) {
 		ha->task_daemon_flags |= SUSPENDED_WAKEUP_FLG;
 
 		/* 30 seconds from now */
@@ -2763,13 +3046,8 @@
 	ddi_rep_get8(pkt->pkt_cmd_acc, (uint8_t *)&els,
 	    (uint8_t *)pkt->pkt_cmd, sizeof (els), DDI_DEV_AUTOINCR);
 
-#if 0
-	QL_PRINT_3(CE_CONT, "(%d): command fhdr:\n", ha->instance);
-	QL_DUMP_3((uint8_t *)&pkt->pkt_cmd_fhdr, 32,
-	    sizeof (fc_frame_hdr_t) / 4);
-	QL_PRINT_3(CE_CONT, "(%d): command:\n", ha->instance);
-	QL_DUMP_3((uint8_t *)&els, 32, sizeof (els) / 4);
-#endif
+	QL_PRINT_10(ha, "els.ls_code=%xh, d_id=%xh\n", els.ls_code,
+	    pkt->pkt_cmd_fhdr.d_id);
 
 	sp->iocb = ha->els_cmd;
 	sp->req_cnt = 1;
@@ -2777,7 +3055,6 @@
 	switch (els.ls_code) {
 	case LA_ELS_RJT:
 	case LA_ELS_ACC:
-		EL(ha, "LA_ELS_RJT\n");
 		pkt->pkt_state = FC_PKT_SUCCESS;
 		rval = FC_SUCCESS;
 		break;
@@ -2845,11 +3122,6 @@
 		break;
 	}
 
-#if 0
-	QL_PRINT_3(CE_CONT, "(%d): response fhdr:\n", ha->instance);
-	QL_DUMP_3((uint8_t *)&pkt->pkt_resp_fhdr, 32,
-	    sizeof (fc_frame_hdr_t) / 4);
-#endif
 	/*
 	 * Return success if the srb was consumed by an iocb. The packet
 	 * completion callback will be invoked by the response handler.
@@ -2859,14 +3131,15 @@
 	} else if (rval == FC_SUCCESS &&
 	    !(pkt->pkt_tran_flags & FC_TRAN_NO_INTR) && pkt->pkt_comp) {
 		/* Do command callback only if no error */
-		ql_awaken_task_daemon(ha, sp, 0, 0);
+		ql_io_comp(sp);
 	}
 
 	if (rval != FC_SUCCESS) {
-		EL(ha, "failed, rval = %xh\n", rval);
+		EL(ha, "rval=%x, ls_code=%xh sent to d_id=%xh, sp=%ph\n",
+		    rval, els.ls_code, pkt->pkt_cmd_fhdr.d_id, sp);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_10(ha, "done\n");
 	}
 	return (rval);
 }
